Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44198)
@@ -2,165 +2,73 @@
 
 import java.text.MessageFormat;
 import java.util.ArrayList;
-import java.util.Collection;
 import java.util.Collections;
-import java.util.HashMap;
 import java.util.HashSet;
 import java.util.List;
-import java.util.Map;
 import java.util.Objects;
 import java.util.Set;
-import org.apache.commons.lang3.ObjectUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.Code;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.fmap.geom.primitive.Envelope;
 
 import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.EMPTY_FORMATTER;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.geom.GeometryUtils;
 
-@SuppressWarnings({"UseSpecificCatch","OverridableMethodCallInConstructor"})
+@SuppressWarnings({"UseSpecificCatch" ,"OverridableMethodCallInConstructor"})
 public class DefaultExpressionBuilder implements ExpressionBuilder {
+    
+    private static final String FORMAT_QUOTE_FOR_STRINGS = "'";
+    private static final String FORMAT_QUOTE_FOR_IDENTIFIERS = "\"";
 
-    public class ConfigBase implements Config {
+    private static final String FORMAT_TRUE = "TRUE";
+    private static final String FORMAT_FALSE = "FALSE";
 
-        protected Map<String, Object> values;
+    private static final String FORMAT_GROUP = "( {0} )";
 
-        public ConfigBase() {
-            this.values = new HashMap<>();
+    private static final String FORMAT_ST_SRID = "ST_SRID({0})";
+    private static final String FORMAT_ST_ASTEXT = "ST_AsText({0})";
+    private static final String FORMAT_ST_ASBINARY = "ST_AsBinary({0})";
+    private static final String FORMAT_ST_ASEWKB = "ST_AsEWKB({0})";
+    private static final String FORMAT_ST_CONTAINS = "ST_Contains(({0}), ({1}))";
+    private static final String FORMAT_ST_CROSSES = "ST_Crosses(({0}), ({1}))";
+    private static final String FORMAT_ST_DISJOINT = "ST_Disjoint(({0}), ({1}))";
+    private static final String FORMAT_ST_EQUALS = "ST_Equals(({0}), ({1}))";
+    private static final String FORMAT_ST_ISCLOSED = "ST_IsClosed({0})";
+    private static final String FORMAT_ST_OVERLAPS = "ST_Overlaps(({0}), ({1}))";
+    private static final String FORMAT_ST_TOUCHES = "ST_Touches(({0}), ({1}))";
+    private static final String FORMAT_ST_WITHIN = "ST_Within(({0}), ({1}))";
+    private static final String FORMAT_ST_ENVELOPE = "ST_Envelope({0})";
+    private static final String FORMAT_ST_INTERSECTS = "ST_Intersects(({0}), ({1}))";
+    private static final String FORMAT_ST_GEOMFROMTEXT = "ST_GeomFromText(({0}), ({1}))";
+    private static final String FORMAT_ST_GEOMFROMWKB = "ST_GeomFromWKB(({0}), ({1}))";
+    private static final String FORMAT_ST_GEOMFROMEWKB = "ST_GeomFromEWKB(({0}), ({1}))";
+    private static final String FORMAT_ST_SIMPLIFY = "ST_Simplify(({0}), ({1}))";
 
-            this.set(Config.has_spatial_functions, true);
-            this.set(Config.support_schemas, true);
-            this.set(Config.constant_true, "(1=1)");
-            this.set(Config.constant_false, "(1=2)");
-            this.set(Config.quote_for_identifiers, "\"");
-            this.set(Config.quote_for_strings, "'");
-            this.set(Config.geometry_type_support, GeometrySupportType.WKB);
-            this.set(Config.group, "( {0} )");
+    private static final String FORMAT_ISNULL = "( ({0}) IS NULL )";
+    private static final String FORMAT_NOTISNULL = "( ({0}) NOT IS NULL )";
+    private static final String FORMAT_OPERATOR_NOT = "( NOT ({0}) )";
 
-            this.set(Config.ST_SRID, "ST_SRID({0})");
-            this.set(Config.ST_AsText, "ST_AsText({0})");
-            this.set(Config.ST_AsBinary, "ST_AsBinary({0})");
-            this.set(Config.ST_AsEWKB, "ST_AsEWKB({0})");
-            this.set(Config.ST_Contains, "ST_Contains(({0}), ({1}))");
-            this.set(Config.ST_Crosses, "ST_Crosses(({0}), ({1}))");
-            this.set(Config.ST_Disjoint, "ST_Disjoint(({0}), ({1}))");
-            this.set(Config.ST_Equals, "ST_Equals(({0}), ({1}))");
-            this.set(Config.ST_IsClosed, "ST_IsClosed({0})");
-            this.set(Config.ST_Overlaps, "ST_Overlaps(({0}), ({1}))");
-            this.set(Config.ST_Touches, "ST_Touches(({0}), ({1}))");
-            this.set(Config.ST_Within, "ST_Within(({0}), ({1}))");
-            this.set(Config.ST_Envelope, "ST_Envelope({0})");
-            this.set(Config.ST_Intersects, "ST_Intersects(({0}), ({1}))");
-            this.set(Config.ST_GeomFromText, "ST_GeomFromText({0}, ({1}))");
-            this.set(Config.ST_GeomFromWKB, "ST_GeomFromWKB(({0}), ({1}))");
-            this.set(Config.ST_GeomFromEWKB, "ST_GeomFromEWKB(({0}), ({1}))");
-            
-            // Por defecto no esta disponible la funcion ST_Simplify
-            // this.set(Config.ST_Simplify, "ST_Simplify(({0}), ({1}))");
-            this.remove_functionality(Config.ST_Simplify);
-            
-            this.set(Config.lcase, "LCASE({0})");
-            this.set(Config.ucase, "UCASE({0})");
-            this.set(Config.iif, "IIF({0},{1},{2})");
-            this.set(Config.ifnull, "IFNULL({0},{1},{2})");
-            
-            this.set(Config.isNull, "( ({0}) IS NULL )");
-            this.set(Config.notIsNull, "( ({0}) NOT IS NULL )");
-            this.set(Config.operator_not, "( NOT ({0}) )");
+    private static final String FORMAT_OPERATOR_AND = "{0} AND {1}";
+    private static final String FORMAT_OPERATOR_OR = "{0} OR {1}";
+    private static final String FORMAT_OPERATOR_EQ = "( ({0}) = ({1}) )";
+    private static final String FORMAT_OPERATOR_NE = "( ({0}) <> ({1}) )";
+    private static final String FORMAT_OPERATOR_GT = "( ({0}) > ({1}) )";
+    private static final String FORMAT_OPERATOR_GE = "( ({0}) >= ({1}) )";
+    private static final String FORMAT_OPERATOR_LT = "( ({0}) < ({1}) )";
+    private static final String FORMAT_OPERATOR_LE = "( ({0}) <= ({1}) )";
+    private static final String FORMAT_OPERATOR_LIKE = "( ({0}) LIKE ({1}) )";
+    private static final String FORMAT_OPERATOR_ILIKE = "( ({0}) ILIKE ({1}) )";
+    private static final String FORMAT_OPERATOR_ADD = "{0} + {1}";
+    private static final String FORMAT_OPERATOR_SUBST = "{0} - {1}";
+    private static final String FORMAT_OPERATOR_MULT = "{0} * {1}";
+    private static final String FORMAT_OPERATOR_DIV = "{0} / {1}";
+    private static final String FORMAT_OPERATOR_CONCAT = "{0} || {1}";
 
-            this.set(Config.operator_AND, "{0} AND {1}");
-            this.set(Config.operator_OR, "{0} OR {1}");
-            this.set(Config.operator_EQ, "( ({0}) = ({1}) )");
-            this.set(Config.operator_NE, "( ({0}) <> ({1}) )");
-            this.set(Config.operator_GT, "( ({0}) > ({1}) )");
-            this.set(Config.operator_GE, "( ({0}) >= ({1}) )");
-            this.set(Config.operator_LT, "( ({0}) < ({1}) )");
-            this.set(Config.operator_LE, "( ({0}) <= ({1}) )");
-            this.set(Config.operator_LIKE, "( ({0}) LIKE ({1}) )");
-            this.set(Config.operator_ILIKE, "( ({0}) ILIKE ({1}) )");
-
-            this.set(Config.operator_add, "{0} + {1}");
-            this.set(Config.operator_subst, "{0} - {1}");
-            this.set(Config.operator_mult, "{0} * {1}");
-            this.set(Config.operator_div, "{0} / {1}");
-            this.set(Config.operator_concat, "{0} || {1}");
-
-        }
-
-        @Override
-        public boolean has_functionality(String functionality) {
-            Object x = this.values.get(functionality);
-            if (x == null) {
-                return false;
-            }
-            if (x instanceof CharSequence && StringUtils.isEmpty((CharSequence) x)) {
-                return false;
-            }
-            return true;
-        }
-
-        @Override
-        public void remove_functionality(String functionality) {
-            this.values.remove(functionality);
-        }
-
-        @Override
-        public boolean has_spatial_functions() {
-            return this.getBoolean(has_spatial_functions);
-        }
-
-        @Override
-        public GeometrySupportType getGeometryTypeSupport() {
-            return (GeometrySupportType) this.get(geometry_type_support);
-        }
-
-        @Override
-        public boolean getBoolean(String name) {
-            return (boolean) this.values.get(name);
-        }
-
-        @Override
-        public String getString(String name) {
-            return (String) this.values.get(name);
-        }
-
-        @Override
-        public Object get(String name) {
-            return this.values.get(name);
-        }
-
-        @Override
-        public void set(String name, Object value) {
-            this.values.put(name, value);
-        }
-    }
-
-    public abstract class AbstractValue implements Value {
-
-        @Override
-        public void accept(Visitor visitor, VisitorFilter filter) {
-            if (filter == null || filter.accept(this)) {
-                visitor.visit(this);
-            }
-        }
-
-    }
-
-    public class ClassVisitorFilter implements VisitorFilter {
-
-        private final Class classFilter;
-
-        public ClassVisitorFilter(Class classFilter) {
-            this.classFilter = classFilter;
-        }
-
-        @Override
-        public boolean accept(Visitable visitable) {
-            return classFilter.isInstance(visitable);
-        }
-
-    }
-
     public class GroupBase extends AbstractValue implements Group {
 
         protected Value value;
@@ -170,7 +78,7 @@
         }
 
         @Override
-        public Value getValue() {
+        public Value value() {
             return value;
         }
 
@@ -182,8 +90,16 @@
 
         @Override
         public String toString() {
-            return MessageFormat.format(config.getString(Config.group), this.value.toString());
+            return this.toString(EMPTY_FORMATTER);
         }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
+            return MessageFormat.format(FORMAT_GROUP, this.value.toString());
+        }
     }
 
     public class VariableBase extends AbstractValue implements Variable {
@@ -195,18 +111,26 @@
         }
 
         @Override
-        public String getName() {
+        public String name() {
             return this.name;
         }
 
         @Override
         public String toString() {
+            return this.toString(EMPTY_FORMATTER);
+        }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
             return identifier(this.name);
         }
 
         @Override
         public int compareTo(Variable o) {
-            return this.name.compareTo(o.getName());
+            return this.name.compareTo(o.name());
         }
 
         @Override
@@ -214,7 +138,7 @@
             if (!(obj instanceof Variable)) {
                 return false;
             }
-            return this.name.equals(((Variable) obj).getName());
+            return this.name.equals(((Variable) obj).name());
         }
 
         @Override
@@ -232,6 +156,15 @@
         protected ParameterType type;
         protected Value srs;
 
+        /*
+        Para un parametre de tipo Geometria, el srs sera siempre un Constant
+        excepto cuando se le asigne una geometria contante al parametro y esta
+        tenga un SRS asignado. En este caso, tanto la geometria como el SRS
+        se trataran como parametros.
+        
+        Si se quiere que el SRS sea un Parameter, se construira como tal y se 
+        asignara a traves del metodo srs(Value srs).
+        */
         public ParameterBase() {
             this.type = ParameterType.Constant;
             this.name = null;
@@ -284,7 +217,7 @@
 
         @Override
         public Parameter srs(IProjection srs) {
-            this.srs = constant(getSRSId(srs));
+            this.srs = constant(srs_id(srs));
             if( this.type == ParameterType.Variable ) {
                 this.type = ParameterType.Geometry;
             }
@@ -292,7 +225,7 @@
         }
 
         @Override
-        public String getName() {
+        public String name() {
             switch (this.type) {
                 case Variable:
                 case Geometry:
@@ -330,6 +263,12 @@
 
         @Override
         public Parameter value(Object value) {
+            if( value instanceof Geometry ) {
+                if( this.srs == null ) {
+                    IProjection proj = ((Geometry)value).getProjection();
+                    this.srs(parameter().value(proj));
+                }
+            }
             this.value = value;
             return this;
         }
@@ -342,23 +281,23 @@
         }
 
         @Override
-        public Object getValue() {
+        public Object value() {
             try {
                 switch (this.type) {
                     case Constant:
-                        if (this.value instanceof Geometry) {
-                            switch (config.getGeometryTypeSupport()) {
+                        if( this.value instanceof Geometry ) {
+                            Geometry geometry = (Geometry) this.value;
+                            switch (geometry_support_type()) {
                                 case EWKB:
-                                    return bytearray(((Geometry) this.value).convertToEWKB());
-                                case NATIVE:
+                                    return GeometryUtils.toEWKB(geometry);
                                 case WKB:
-                                    return bytearray(((Geometry) this.value).convertToWKB());
+                                    return GeometryUtils.toWKB(geometry);
                                 case WKT:
                                 default:
-                                    return ((Geometry) this.value).convertToWKT();
+                                    return GeometryUtils.toWKT(geometry);
                             }
                         } else if (this.value instanceof IProjection) {
-                            return getSRSId((IProjection) this.value);
+                            return srs_id((IProjection) this.value);
                         }
                         return this.value;
                     case Variable:
@@ -372,46 +311,92 @@
         }
 
         @Override
-        public ParameterType getType() {
+        public ParameterType type() {
             return this.type;
         }
 
         @Override
-        public Value getSRS() {
+        public Value srs() {
             return this.srs;
         }
 
         @Override
         public String toString() {
+            return this.toString(EMPTY_FORMATTER);
+        }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
             switch (this.type) {
                 case Constant:
+                    if( value instanceof Geometry ) {
+                        switch (geometry_support_type()) {
+                            case EWKB:
+                                return MessageFormat.format(
+                                    FORMAT_ST_GEOMFROMEWKB,
+                                    "?",
+                                    getSRS(formatter)
+                                );
+                            case WKB:
+                                return MessageFormat.format(
+                                    FORMAT_ST_GEOMFROMWKB,
+                                    "?",
+                                    getSRS(formatter)
+                                );
+                            case WKT:
+                            default:
+                                return MessageFormat.format(
+                                    FORMAT_ST_GEOMFROMTEXT,
+                                    "?",
+                                    getSRS(formatter)
+                                );
+                        }
+                    }
                 case Variable:
                 default:
                     return "?";
                 case Geometry:
-                    switch (config.getGeometryTypeSupport()) {
+                    switch (geometry_support_type()) {
                         case EWKB:
                             return MessageFormat.format(
-                                    config.getString(Config.ST_GeomFromEWKB),
-                                    "?",
-                                    String.valueOf(this.srs.toString())
+                                FORMAT_ST_GEOMFROMEWKB,
+                                "?",
+                                getSRS(formatter)
                             );
                         case WKB:
                             return MessageFormat.format(
-                                    config.getString(Config.ST_GeomFromWKB),
-                                    "?",
-                                    String.valueOf(this.srs.toString())
+                                FORMAT_ST_GEOMFROMWKB,
+                                "?",
+                                getSRS(formatter)
                             );
                         case WKT:
                         default:
                             return MessageFormat.format(
-                                    config.getString(Config.ST_GeomFromText),
-                                    "?",
-                                    String.valueOf(this.srs.toString())
+                                FORMAT_ST_GEOMFROMTEXT,
+                                "?",
+                                getSRS(formatter)
                             );
                     }
             }
         }
+        
+        private String getSRS(Formatter formatter) {
+            if( this.srs!=null ) {
+                return this.srs.toString(formatter);
+            }
+            if( this.value instanceof Geometry ) {
+                IProjection proj = ((Geometry)this.value).getProjection();
+                Object s = srs_id(proj);
+                if( s == null ) {
+                    throw new IllegalArgumentException("A parameter of type Geometry with an invalid SRS.");
+                }
+                return s.toString();
+            }
+            throw new IllegalArgumentException("The parameter of type Geometry need a SRS.");
+        }
     }
 
     public class ConstantBase extends AbstractValue implements Constant {
@@ -423,23 +408,64 @@
         }
 
         @Override
-        public Object getValue() {
+        public Object value() {
             return this.value;
         }
 
         @Override
         public String toString() {
+            return this.toString(EMPTY_FORMATTER);
+        }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
+            if( this.value==null ) {
+                return "NULL";
+            }
+            if( this.value instanceof byte[] ) {
+                return "DECODE('"+bytearray_hex((byte[])this.value)+"','hex')";
+            }
             if (this.value instanceof String) {
                 return string((String) this.value);
             }
+            if( this.value instanceof Geometry ) {
+                Geometry geometry = (Geometry) this.value;
+                switch (geometry_support_type()) {
+                    case EWKB:
+                        return MessageFormat.format(
+                                FORMAT_ST_GEOMFROMEWKB,
+                                "DECODE('"+bytearray_hex(GeometryUtils.toEWKB(geometry))+"','hex')",
+                                String.valueOf(srs_id(geometry.getProjection()))
+                        );
+                    case WKB:
+                        return MessageFormat.format(
+                                FORMAT_ST_GEOMFROMWKB,
+                                "DECODE('"+bytearray_hex(GeometryUtils.toWKB(geometry))+"','hex')",
+                                String.valueOf(srs_id(geometry.getProjection()))
+                        );
+                    case WKT:
+                    default:
+                        return MessageFormat.format(
+                                FORMAT_ST_GEOMFROMTEXT,
+                                string(GeometryUtils.toWKT(geometry)),
+                                String.valueOf(srs_id(geometry.getProjection()))
+                        );
+                }
+            }
+            if( this.value instanceof IProjection ) {
+                return Objects.toString(srs_id((IProjection)(this.value)));
+            }
             if (this.value instanceof Boolean) {
                 if (((Boolean) this.value)) {
-                    return config.getString(Config.constant_true);
+                    return FORMAT_TRUE;
                 } else {
-                    return config.getString(Config.constant_false);
+                    return FORMAT_FALSE;
                 }
             }
-            return ObjectUtils.toString(this.value, "");
+            return Objects.toString(this.value, "");
         }
     }
 
@@ -466,7 +492,7 @@
         }
 
         @Override
-        public Object getValue() {
+        public Object value() {
             return this.value;
         }
 
@@ -490,57 +516,15 @@
 
         @Override
         public String toString() {
-            return ObjectUtils.toString(this.value, "");
+            return this.toString(EMPTY_FORMATTER);
         }
-    }
-
-    public class GeometryValueBase extends AbstractValue implements GeometryValue {
-
-        protected Geometry geometry;
-        protected IProjection projection;
-
-        public GeometryValueBase(Geometry geometry, IProjection projection) {
-            this.geometry = geometry;
-            this.projection = projection;
-        }
-
+        
         @Override
-        public Geometry getGeometry() {
-            return this.geometry;
-        }
-
-        @Override
-        public IProjection getSRS() {
-            return this.projection;
-        }
-
-        @Override
-        public String toString() {
-            try {
-                switch (config.getGeometryTypeSupport()) {
-                    case EWKB:
-                        return MessageFormat.format(
-                                config.getString(Config.ST_GeomFromEWKB),
-                                bytearray(this.geometry.convertToEWKB()),
-                                String.valueOf(getSRSId(this.projection))
-                        );
-                    case WKB:
-                        return MessageFormat.format(
-                                config.getString(Config.ST_GeomFromWKB),
-                                bytearray(this.geometry.convertToWKB()),
-                                String.valueOf(getSRSId(this.projection))
-                        );
-                    case WKT:
-                    default:
-                        return MessageFormat.format(
-                                config.getString(Config.ST_GeomFromText),
-                                string(this.geometry.convertToWKT()),
-                                String.valueOf(getSRSId(this.projection))
-                        );
-                }
-            } catch (Exception ex) {
-                throw new RuntimeException("Can't convert geometry to string.", ex);
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
             }
+            return Objects.toString(this.value, "");
         }
     }
 
@@ -574,7 +558,7 @@
         }
 
         @Override
-        public String getName() {
+        public String name() {
             return this.name;
         }
 
@@ -588,6 +572,14 @@
 
         @Override
         public String toString() {
+            return this.toString(EMPTY_FORMATTER);
+        }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
             if( this.format==null ) {
                 StringBuilder builder = new StringBuilder();
                 builder.append(name);
@@ -597,10 +589,10 @@
                     for (Value value : this.parameters) {
                         if( first ) {
                             first=false;
-                            builder.append(value.toString());
+                            builder.append(value.toString(formatter));
                         } else {
                             builder.append(", ");
-                            builder.append(value.toString());
+                            builder.append(value.toString(formatter));
                         }
                     }
                 }
@@ -610,7 +602,7 @@
             if (this.parameters != null && !this.parameters.isEmpty()) {
                 List<String> values = new ArrayList<>();
                 for (Value value : this.parameters) {
-                    values.add(value.toString());
+                    values.add(value.toString(formatter));
                 }
                 return MessageFormat.format(format, values.toArray());
             } else {
@@ -619,6 +611,54 @@
         }
     }
 
+    public class MethodBase extends FunctionBase implements Method {
+
+        private final Value instance;
+        
+        public MethodBase(Value instance, String name) {
+            super(name);
+            this.instance = instance;
+        }
+
+        @Override
+        public Value instance() {
+            return this.instance;
+        }
+
+        @Override
+        public void accept(Visitor visitor, VisitorFilter filter) {
+            this.instance.accept(visitor, filter);
+            super.accept(visitor, filter);
+        }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
+            StringBuilder builder = new StringBuilder();
+            builder.append(this.instance.toString(formatter));
+            builder.append("->");
+            builder.append(this.name());
+            builder.append(name);
+            builder.append("(");
+            if (this.parameters != null && !this.parameters.isEmpty()) {
+                boolean first = true;
+                for (Value value : this.parameters) {
+                    if( first ) {
+                        first=false;
+                        builder.append(value.toString(formatter));
+                    } else {
+                        builder.append(", ");
+                        builder.append(value.toString(formatter));
+                    }
+                }
+            }
+            builder.append(")");
+            return builder.toString();
+        }
+    }
+
     public class BinaryOperatorBase extends AbstractValue implements BinaryOperator {
 
         protected String name;
@@ -632,7 +672,7 @@
         }
 
         @Override
-        public String getName() {
+        public String name() {
             return this.name;
         }
 
@@ -644,42 +684,62 @@
         }
 
         @Override
-        public BinaryOperator setLeft(Value operand) {
+        public BinaryOperator left(Value operand) {
             this.left = operand;
             return this;
         }
 
         @Override
-        public BinaryOperator setRight(Value operand) {
+        public BinaryOperator right(Value operand) {
             this.right = operand;
             return this;
         }
 
         @Override
-        public Value getLeft() {
+        public Value left() {
             return this.left;
         }
 
         @Override
-        public Value getRight() {
+        public Value right() {
             return this.right;
         }
 
         @Override
         public String toString() {
-            return MessageFormat.format(
-                    format,
-                    this.left.toString(),
-                    this.right.toString()
-            );
+            return this.toString(EMPTY_FORMATTER);
         }
+        
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if( formatter.canApply(this) ) {
+                return formatter.format(this);
+            }
+            if( this.format==null ) {
+                StringBuilder builder = new StringBuilder();
+                builder.append("(");
+                builder.append(this.left.toString(formatter));
+                builder.append(" ");
+                builder.append(this.name);
+                builder.append(" ");
+                builder.append(this.right.toString(formatter));
+                builder.append(")");
+                return builder.toString();
+            } else {
+                return MessageFormat.format(
+                        format,
+                        this.left.toString(formatter),
+                        this.right.toString(formatter)
+                );
+            }
+        }
     }
 
+    protected GeometrySupportType geometrySupportType;
     protected Value value;
-    protected Config config;
 
     public DefaultExpressionBuilder() {
-        this.config = new ConfigBase();
+        this.geometrySupportType = GeometrySupportType.WKB;
     }
 
     @Override
@@ -688,17 +748,23 @@
     }
 
     @Override
-    public Config getConfig() {
-        return this.config;
+    public GeometrySupportType geometry_support_type() {
+        return this.geometrySupportType;
     }
 
     @Override
-    public Value getValue() {
+    public ExpressionBuilder geometry_support_type(GeometrySupportType geometrySupportType) {
+        this.geometrySupportType = geometrySupportType;
+        return this;
+    }
+
+    @Override
+    public Value value() {
         return this.value;
     }
 
     @Override
-    public ExpressionBuilder setValue(Value value) {
+    public ExpressionBuilder value(Value value) {
         this.value = value;
         return this;
     }
